#pragma rtGlobals=1		// Use modern global access method.
#pragma version = 0.01

Macro compute_1st_moment(Swave,Xwave,loE,hiE,Q)
	String Swave
	Prompt Swave,"wave with S(q,w) for computing w S(q,w) dw"
	String Xwave
	Prompt Xwave,"wave with eV scale",popup, "_none_;(----);"+WaveList("e*", ";", "")
	Variable loE=10
	Variable hiE=70
	Prompt loE,"low end of energy range for moment (eV)"
	Prompt hiE,"low end of energy range for moment (eV)"
	Variable Q = 3.5
	Prompt Q,"Q  (1/)"

	Silent 1
	Variable moment

	if ( (strlen(Xwave)<1) ||  (cmpstr(Xwave, "none")==0) || (cmpstr(Xwave, "_none_")==0) )
		moment = calc1stMoment($Swave,loE,hiE,Q)
		print "w '"+Swave+"'(q,w) dw = "+num2str(moment*Q^2/2.975^2)+",    and w S(q,w) dw / q^2 = "+num2str(moment)
	else
		moment = calc1stMomentX($Swave,$Xwave,loE,hiE,Q)
		print "w '"+Swave+"'(q,'"+Xwave+"'(w)) dw = "+num2str(moment*Q^2/2.975^2)+",    and w S(q,w) dw / q^2 = "+num2str(moment)
	endif
EndMacro

Function calc1stMoment(Swave,loE,hiE,Q)
	Wave Swave
	Variable loE	,hiE		// low and high range of moment
	Variable Q				// Q in 1/

	Variable moment=0
	loE = abs(loE)
	hiE = abs(hiE)

	duplicate/O Swave first_moment
	first_moment *= x
	moment = abs(area(first_moment,loE,hiE))
	KillWaves/Z first_moment
	return moment*2.975^2/Q^2
End

Function calc1stMomentX(Swave,Xwave,loE,hiE,Q)
	Wave Swave
	Wave Xwave
	Variable loE	,hiE		// low and high range of moment
	Variable Q				// Q in 1/

	Variable moment=0
	loE = abs(loE)
	hiE = abs(hiE)

	duplicate/O Swave first_moment
	first_moment = Swave * abs(Xwave[p])
	Execute "Interpolate/N=512/E=2/Y=first_moment_CS first_moment /X="+NameOfWave(Xwave)
	moment = abs(area(first_moment_CS,loE,hiE))
	KillWaves/Z first_moment,first_moment_CS
	return moment*2.975^2/Q^2
EndMacro

Proc compute_1st_moment_OLD(Swave,Xwave,loE,hiE,Q)
	String Swave
	Prompt Swave,"wave with S(q,w) for computing w S(q,w) dw"
	String Xwave
	Prompt Xwave,"wave with eV scale",popup, "_none_;(----);"+WaveList("e*", ";", "")
	Variable loE=10
	Variable hiE=70
	Prompt loE,"low end of energy range for moment (eV)"
	Prompt hiE,"low end of energy range for moment (eV)"
	Variable Q = 3.5
	Prompt Q,"Q  (1/)"

	Silent 1
	Variable moment=0

	if (loE<0)
		loE *= -1
	endif
	if (hiE<0)
		hiE *= -1
	endif

	duplicate/O $Swave first_moment

	if ( (cmpstr(Xwave, "none")==0) || (cmpstr(Xwave, "_none_")==0) )
		first_moment *= x
		moment = abs(area(first_moment,loE,hiE))
		print "w '"+Swave+"'(q,w) dw = "+num2str(moment)+",    and w S(q,w) dw / q^2 = "+num2str(moment*2.975^2/Q^2)
	else
		first_moment = $Swave * abs($Xwave[p])
		Interpolate/N=512/E=2/Y=first_moment_CS first_moment /X=$Xwave
		moment = abs(area(first_moment_CS,loE,hiE))
		print "w '"+Swave+"'(q,'"+Xwave+"'(w)) dw = "+num2str(moment)+",    and w S(q,w) dw / q^2 = "+num2str(moment*2.975^2/Q^2)
	endif
	KillWaves/Z first_moment,first_moment_CS
EndMacro

